/**
 *
 * Copyright (c) 2006-2016, Speedment, Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); You may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package com.speedment.runtime.field.predicate;

import com.speedment.runtime.annotation.Api;
import com.speedment.runtime.field.predicate.trait.HasEffectivePredicateType;
import com.speedment.runtime.field.predicate.trait.HasNegated;
import com.speedment.runtime.field.predicate.trait.HasPredicateType;

import java.util.function.Predicate;
import com.speedment.runtime.field.predicate.trait.HasField;

/**
 * The base interface for all {@link Predicate predicates} generated by
 * Speedment entity fields.
 * 
 * @param <ENTITY>  the entity type that is being tested
 * 
 * @author  Per Minborg
 * @since   2.1.0
 */
@Api(version = "3.0")
public interface FieldPredicate<ENTITY> extends
    Predicate<ENTITY>,
    HasPredicateType,
    HasEffectivePredicateType,
    HasField<ENTITY>,
    HasNegated {

}