/**
 *
 * Copyright (c) 2006-2016, Speedment, Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); You may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package com.speedment.runtime.internal.platform.component.impl;

import com.speedment.runtime.Speedment;
import com.speedment.runtime.internal.DefaultApplicationBuilder;
import com.speedment.runtime.internal.EmptyApplicationMetadata;
import org.junit.Test;

import static org.junit.Assert.assertNotNull;

/**
 *
 * @author Emil Forslund
 */
public class CreateSpeedmentInstanceTest {
    
    @Test
    public void createSpeedmentInstance() {
        final Speedment speedment = new DefaultApplicationBuilder(EmptyApplicationMetadata.class)
            .withCheckDatabaseConnectivity(false)
            .withValidateRuntimeConfig(false)
            .build();
        
        assertNotNull(speedment);
    }
    
}
